﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        Point _mousePos;
        public MainPage()
        {
            InitializeComponent();
            this.MouseMove += MainPage_MouseMove;
        }

        void MainPage_MouseMove(object sender, MouseEventArgs e)
        {
            _mousePos = e.GetPosition(xamGrid1);
        }

        private void XamGrid_SelectedRowsCollectionChanged(object sender, Infragistics.Controls.Grids.SelectionCollectionChangedEventArgs<Infragistics.Controls.Grids.SelectedRowsCollection> e)
        {
            List<UIElement> elements = VisualTreeHelper.FindElementsInHostCoordinates(_mousePos, xamGrid1).ToList();
            if (elements != null && elements.Count > 0)
            {
                TextBox tb = (TextBox)elements.Where(x => x.GetType() == typeof(TextBox)).FirstOrDefault();
                if (tb != null)
                {
                    xamGrid1.SelectedRowsCollectionChanged -= XamGrid_SelectedRowsCollectionChanged;

                    xamGrid1.SelectionSettings.SelectedRows.Clear();
                    foreach (Row row in e.PreviouslySelectedItems)
                        xamGrid1.SelectionSettings.SelectedRows.Add(row);

                    xamGrid1.SelectedRowsCollectionChanged += XamGrid_SelectedRowsCollectionChanged;
                }
            }
        }
    }

    public class SampleDataItem
    {
        public string name { get; set; }
        public string department { get; set; }
        public double salary { get; set; }
        public string email { get; set; }
    }

    public class SampleData : ObservableCollection<SampleDataItem>
    {
        public SampleData()
        {
            Add(new SampleDataItem { name = "Joe", department = "Sales", salary = 70000.0, email = "joe@email.com" });
            Add(new SampleDataItem { name = "Mary", department = "Engineering", salary = 71000.0, email = "mary@email.com" });
            Add(new SampleDataItem { name = "Jim", department = "Sales", salary = 72000.0, email = "jim@email.com" });
        }
    }
}
